<template>
  <input
    v-if="parameter.type === 'string+select'"
    v-bind="addProperties(parameter, HTMLInputElement)"
    v-model="$v[parameter.key].$model"
    :class="{ 'is-invalid': $v[parameter.key].$invalid }"
    class="form-control"
    style="background-color: transparent; cursor: auto"
    type="text"
    readonly="readonly"
  />
</template>

<script>
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    validations: {
      type: Function,
      default: () => ({}),
    },
    changeStateScenario: {
      type: Function,
      default: () => ({}),
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      HTMLInputElement: null,
      [this.parameter.key]: '',
    };
  },
  validations() {
    return this.validations(this.parameter);
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
  },
  watch: {
    // Changes on the action
    param() {
      this[this.parameter.key] = this.getParamValue();
      this.changeStateScenario(
        this.parameter.key,
        this.$v[this.parameter.key].$invalid
      );
    },
  },
  mounted() {
    this.HTMLInputElement = HTMLInputElement;
    if (this.$v[this.parameter.key].$invalid) {
      this.changeStateScenario(this.parameter.key, true);
    }
  },
  beforeMount() {
    this[this.parameter.key] = this.getParamValue();
  },
  methods: {
    getParamValue() {
      let value = '';
      if (this.param.value != null && this.param.value !== undefined) {
        value = this.param.options[this.param.value];
      } else if (this.param.default) {
        value = this.param.options[this.param.default];
      }
      return value;
    },
  },
};
</script>
